#include "BossShot.h"

//RXgN^
BossShot::BossShot( void )
{
	for(int i = 0; i < BOSS_SHOT_KIND_MAX; i++)
	{
		std::ostringstream bullet_image;

		bullet_image << "./SettingFiles/BossShotImage/Shot" << ( i + 1 ) << ".png";

		bulletImage.push_back( DX::dxCentral.LoadTexture( bullet_image.str().c_str() ) );

		if( bulletImage.back() == -1 )
		{
			ErrorMsgBox( "{XVbgC[W̓ǂݍ݃G[B\nI܂B" );
			exit( -1 );
		}

		imageSize.push_back(
			Size( 
			DX::dxCentral.GetTextureWidth( bulletImage.back() ),
			DX::dxCentral.GetTextureHeight( bulletImage.back() )
			)
			);

		if( imageSize.back().width == -1 || imageSize.back().height == -1)
		{
			ErrorMsgBox( "{XVbgC[WTCY̓ǂݍ݃G[B\nI܂B" );
			exit( -1 );
		}
	}
}

//fXgN^
BossShot::~BossShot( void )
{
}

//@Xe[WɌĂяoB
void BossShot::Initialize()
{
	for( int i = 0; i < BOSS_SHOT_SHOW_MAX; i++ )
	{
		shotData[ i ].Initialize();
	}
}

//VbgS̊Ǘ
void BossShot::ShotControl( const BossData* boss_data, const PlayerData* player_data )
{
	for( int i = 0; i < BOSS_SHOT_SHOW_MAX; i++ )
	{
		if( shotData[ i ].flag != 0 )
		{
			shotPattern.ShotPattern( shotData[ i ], *boss_data, *player_data );
			ShotCalc( *boss_data, i );
			shotData[ i ].count++;
		}
	}

	DrawBossShot();
}

//Vbg̓o^ BossData.barrage_kindɂĂB
void BossShot::RegisterShot( int barrage_kind )
{
	for( int i = 0; i < BOSS_SHOT_SHOW_MAX; i++ )
	{
		if( shotData[ i ].flag == 0 )
		{
			shotData[ i ].flag = 1;
			shotData[ i ].kind = barrage_kind;//ꂪp^[Ɏgp܂B
			shotData[ i ].count = 0;
			return;
		}
	}
}

//Vbg̃LZ
void BossShot::ShotCancel()
{
	for( int i = 0; i < BOSS_SHOT_SHOW_MAX; i++ )
	{
		if( shotData[ i ].flag != 0 )
		{
			shotData[ i ].flag = 2;//ef[^̓o^֎~
			break;
		}
	}
}

//Vbg
void BossShot::ShotClear( int shot_num, int bullet_num )
{
	shotData[ shot_num ].bullet[ bullet_num ].flag = 0;
}

//Vbgf[^Ԃ
const BossShotData* BossShot::GetShotData() const
{
	return &shotData[0];
}

//ȇ傫Ԃ
const vector<Size>* BossShot::GetBulletSize() const
{
	return &imageSize;
}

//evZs܂B
void BossShot::ShotCalc( const BossData& boss_data, int shot_num )
{
	if( boss_data.flag != 1 )
	{
		shotData[ shot_num ].flag = 2;//e̓o^sԂ
	}

	for( int i = 0; i < BULLET_DATA_MAX; i++ )
	{
		if( shotData[ shot_num ].bullet[ i ].flag > 0 )
		{
			shotData[ shot_num ].bullet[ i ].location.x +=
				cos( shotData[ shot_num ].bullet[ i ].angle ) * shotData[ shot_num ].bullet[ i ].speed;

			shotData[ shot_num ].bullet[ i ].location.y +=
				sin( shotData[ shot_num ].bullet[ i ].angle ) * shotData[ shot_num ].bullet[ i ].speed;

			shotData[ shot_num ].bullet[ i ].count++;

			if( shotData[ shot_num ].bullet[ i ].location.x < -50 ||
				shotData[ shot_num ].bullet[ i ].location.x > LIMIT_SCOPE_END_X + 50 ||
				shotData[ shot_num ].bullet[ i ].location.y < -50 ||
				shotData[ shot_num ].bullet[ i ].location.y > LIMIT_SCOPE_END_Y + 50 )
			{
				shotData[ shot_num ].bullet[ i ].flag = 0;//OBeB
			}
		}
	}

	for( int k = 0; k < BULLET_DATA_MAX; k++ )
	{
		if( shotData[ shot_num ].bullet[ k ].flag > 0 )
		{
			return;
		}
	}

	if( boss_data.flag == 0 )
	{
		shotData[ shot_num ].flag = 0;
	}
}

void BossShot::DrawBossShot()
{
	for( int i = 0; i < BOSS_SHOT_SHOW_MAX; i++ )
	{
		if( shotData[ i ].flag > 0 )
		{
			for( int k = 0; k < BULLET_DATA_MAX; k++ )
			{
				if( shotData[ i ].bullet[ k ].flag != 0 )
				{
					DX::dxCentral.DrawTexture(
						bulletImage[ shotData[ i ].bullet[ k ].kind ],
						0,
						0,
						0,
						0,
						static_cast<int>( shotData[ i ].bullet[ k ].location.x - ( imageSize[ shotData[ i ].bullet[ k ].kind ].width / 2 ) ),
						static_cast<int>( shotData[ i ].bullet[ k ].location.y - ( imageSize[ shotData[ i ].bullet[ k ].kind ].height / 2 ) ),
						static_cast<int>( imageSize[ shotData[ i ].bullet[ k ].kind ].width ),
						static_cast<int>( imageSize[ shotData[ i ].bullet[ k ].kind ].height ) );
				}
			}
		}
	}
}