#include "DxDraw.h"

DxDraw::DxDraw(void) : createD3D( NULL ),
	renderD3DDevice( NULL ),
	spriteD3D( NULL ),
	fontD3D( NULL )
{
}

DxDraw::~DxDraw(void)
{
	if( fontD3D != NULL )
	{
		SAFE_RELEASE( fontD3D );
	}

	if( renderD3DDevice != NULL )
	{
		SAFE_RELEASE( renderD3DDevice );
	}

	if( createD3D != NULL )
	{
		SAFE_RELEASE( createD3D );
	}

	if( spriteD3D != NULL )
	{
		SAFE_RELEASE( spriteD3D );
	}
}

//
HRESULT DxDraw::Initialize( HWND hwnd )
{
	if( NULL == ( createD3D = Direct3DCreate9( D3D_SDK_VERSION ) ) )
	{
		return E_FAIL;
	}

	D3DPRESENT_PARAMETERS d3dParam;//ep[^\
	ZeroMemory( &d3dParam, sizeof( d3dParam ) );

	d3dParam.Windowed = TRUE;//TRUE̓EBhE`@FALSEȂS
	d3dParam.SwapEffect = D3DSWAPEFFECT_DISCARD;//obNobt@͐؂ւjɎw
	d3dParam.BackBufferFormat = D3DFMT_UNKNOWN;//obNobt@̐F[x

	if( FAILED( createD3D->CreateDevice( 
		D3DADAPTER_DEFAULT,//gpfBXvCA_v^
		D3DDEVTYPE_HAL,//foCX^Cv
		hwnd,//ΏۃEBhEnh
		D3DCREATE_SOFTWARE_VERTEXPROCESSING,//foCXIvV
		&d3dParam,//p[^̍\
		&renderD3DDevice ) ) )//foCXԂ|C^
	{
		return E_FAIL;
	}

	//XvCg̍쐬
	if( FAILED( D3DXCreateSprite( renderD3DDevice, &spriteD3D ) ) )
	{
		return E_FAIL;
	}

	return S_OK;
}

//Direct3DfoCX̍쐬@tXN[ (fobOł͂̃[h͊댯j
HRESULT DxDraw::InitializeFullScreen( HWND hwnd )
{
	if( NULL == ( createD3D = Direct3DCreate9( D3D_SDK_VERSION ) ) )
	{
		return E_FAIL;
	}

	D3DDISPLAYMODE display_mode;
	createD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &display_mode );

	D3DPRESENT_PARAMETERS d3dParam;//ep[^\
	ZeroMemory( &d3dParam, sizeof( d3dParam ) );

	d3dParam.Windowed = FALSE;//TRUE̓EBhE`@FALSEȂS
	d3dParam.BackBufferWidth = display_mode.Width;//obNobt@̕
	d3dParam.BackBufferHeight = display_mode.Height;//obNobt@̍
	d3dParam.SwapEffect = D3DSWAPEFFECT_DISCARD;//obNobt@͐؂ւjɎw
	d3dParam.BackBufferFormat = display_mode.Format;//obNobt@̐F[x
	d3dParam.FullScreen_RefreshRateInHz = display_mode.RefreshRate;//tbV[g

	if( FAILED( createD3D->CreateDevice( 
		D3DADAPTER_DEFAULT,//gpfBXvCA_v^
		D3DDEVTYPE_HAL,//foCX^Cv
		hwnd,//ΏۃEBhEnh
		D3DCREATE_HARDWARE_VERTEXPROCESSING,//foCXIvV in[hEFAj
		&d3dParam,//p[^̍\
		&renderD3DDevice ) ) )//foCXԂ|C^
	{
		if( FAILED( createD3D->CreateDevice( 
			D3DADAPTER_DEFAULT,//gpfBXvCA_v^
			D3DDEVTYPE_HAL,//foCX^Cv
			hwnd,//ΏۃEBhEnh
			D3DCREATE_SOFTWARE_VERTEXPROCESSING,//foCXIvV (\tgEFAj
			&d3dParam,//p[^̍\
			&renderD3DDevice ) ) )//foCXԂ|C^
		{
			return E_FAIL;
		}
	}

	//XvCg̍쐬
	if( FAILED( D3DXCreateSprite( renderD3DDevice, &spriteD3D ) ) )
	{
		return E_FAIL;
	}

	return S_OK;
}

//tHgiMSSVbN̂݁@KvȂ΂ƂŕςjG[Ȃ-1@0
int DxDraw::InitializeFont( LPCTSTR font_name, int height, int width )
{
	if( FAILED( D3DXCreateFont(
					renderD3DDevice,//foCX
					height,//̍
					width,//
					FW_NORMAL,//tHg
					1,//~bv}bvx
					FALSE,//C^bNtO
					DEFAULT_CHARSET,//Zbg
					OUT_DEFAULT_PRECIS,//o͐x
					ANTIALIASED_QUALITY,//o͕i
					DEFAULT_PITCH | FF_SWISS,//tHgsb`ƃt@~
					font_name,//tHg
					&fontD3D )))//LPD3DXFONT̃AhX
	{
		return -1;
	}

	return 0;
}

//`
int DxDraw::DrawString( LPCSTR draw_str, int left, int right, int top, int bottom )
{
	if( draw_str == NULL || fontD3D == NULL || renderD3DDevice == NULL )
	{
		return -1;
	}

	if( SUCCEEDED( renderD3DDevice->BeginScene() ) )
	{
		RECT rect;
		SetRect( &rect, left, top, right, bottom );

		if( fontD3D->DrawTextA( 
					NULL,//XvCg|C^@Ȃł悢
					draw_str,//`敶
					-1,//@-1őS
					&rect,//`͈
					DT_LEFT | DT_NOCLIP,//tH[}bg
					D3DCOLOR_ARGB( 255, 255, 255, 255 ) ) == 0 )
		{
			renderD3DDevice->EndScene();
			return -1;
		}

		renderD3DDevice->EndScene();
		return 0;
	}

	return -1;
}

//eNX`̃[h  .bmpA.ddsA.dibA.jpgA.pngA .tga
int DxDraw::LoadTexture( LPCSTR filename )
{
	int insert_index = -1;
	int last_index = textureVector.size();

	//vectorzɋ󂫂΂LoadB
	for( int i = 0; i < last_index; i++ )
	{
		if( textureVector[ i ] == NULL )
		{
			insert_index = i;
			break;
		}
	}

	//vectorzɋ󂫂ȂȂVȗ̈쐬ALoadB
	if( insert_index == -1 )
	{
		textureVector.push_back( NULL );//V̗vf쐬
		insert_index = textureVector.size() - 1;
	}

	if( FAILED( D3DXCreateTextureFromFileExA(
		renderD3DDevice,
		filename,
		0,
		0,
		0,
		0,
		D3DFMT_UNKNOWN,
		D3DPOOL_DEFAULT,
		D3DX_FILTER_NONE,
		D3DX_DEFAULT,
		0,
		NULL,
		NULL,
		&textureVector[ insert_index ] )))
	{
		if( insert_index == textureVector.size() - 1 )
		{
			textureVector.pop_back();//vf폜
		}
		else
		{
			textureVector[ insert_index ] = NULL;//rւ̑}ȂNULL邾
		}

		return -1;
	}
	else
	{
		return textureVector.size() - 1;//ǉvfԍԂB
	}
}

//ʂNA
void DxDraw::ClearScreen()
{
	if( NULL == renderD3DDevice )
	{
		return;
	}

	//wiŃNA
	renderD3DDevice->Clear( 0, NULL, D3DCLEAR_TARGET, D3DCOLOR_XRGB( 0, 0, 0 ), 1.0f, 0 );
}

//eNX``@G[Ȃ-1Ԃ
//index: int^@textureVector̃CfbNXiLoadĂKvB)
//src_  x & y & width & height: 摜̐؂oʒu Jn_i x, y )Awidth,heighẗʒu܂ł`\ƂBig~OƂƁj
//draw_  x & y & width & height: 摜XN[ɕ`ʒuA傫
int DxDraw::DrawTexture( int index, int src_x, int src_y, int src_width, int src_height, int draw_x, int draw_y, int draw_width, int draw_height )
{
	if( NULL == renderD3DDevice || 
		src_x < 0 || 
		src_y < 0 || 
		src_width < 0 || 
		src_height < 0 || 
		draw_width < 0 || 
		draw_height < 0 )
	{
		return -1;
	}

	if( SUCCEEDED( renderD3DDevice->BeginScene() ) )
	{
		int temp_size = static_cast<int>( textureVector.size() );

		if( temp_size > index && temp_size > 0 )
		{
			D3DSURFACE_DESC desc;
			D3DXMATRIX scaling, translation, result_matrix;

			textureVector[index]->GetLevelDesc( 0, &desc );//eNX`TCY̎擾
			
			//0̂Ƃ͌摜̂܂
			if( src_width == 0 )
			{
				src_width = desc.Width;
			}

			//0̂Ƃ͌摜̂܂
			if( src_height == 0 )
			{
				src_height = desc.Height;
			}

			D3DXMatrixScaling( &scaling, ( ( float )draw_width / ( float )( src_width - src_x ) ), ( ( float )draw_height / ( float )( src_height - src_y ) ), 0 );//gk
			D3DXMatrixTranslation( &translation, ( float )draw_x, ( float )draw_y, 0 );//ړ
			D3DXMatrixMultiply( &result_matrix, &scaling, &translation );//

			RECT rect={ src_x, src_y, src_width, src_height };//摜̕`ʒui܂肱Ńg~Oj

			spriteD3D->SetTransform( &result_matrix );
			spriteD3D->Begin( D3DXSPRITE_ALPHABLEND );
			spriteD3D->Draw( textureVector[index], &rect, NULL, NULL, 0xFFFFFFFF);
			spriteD3D->End();
		}

		renderD3DDevice->EndScene();

		return 0;
	}
	
	return -1;
}

//eNX`̍폜
void DxDraw::DeleteTexture( int delete_index )
{
	//Ō̃CfbNXȂPpop_back()ō폜
	if( textureVector.size() - 1 == delete_index )
	{
		textureVector.pop_back();
	}
	else
	{
		std::vector<LPDIRECT3DTEXTURE9>::iterator delete_iterator = textureVector.erase( textureVector.begin() + delete_index );
		textureVector.insert( delete_iterator, NULL );
	}
}

//ǂݍ񂾃eNX`Sč폜
void DxDraw::DeleteAllTexture()
{
	//ǂݍ񂾃eNX`Sč폜
	textureVector.clear();
}

//ǂݍݍς݂indexԍ̃eNX`̕Ԃ@G[Ȃ-1
int DxDraw::GetTextureWidth( int index )
{
	int temp_size = static_cast<int>( textureVector.size() );

	if( temp_size > index && temp_size > 0 )
	{
		D3DSURFACE_DESC desc;
		textureVector[index]->GetLevelDesc( 0, &desc );//eNX`TCY̎擾
		return desc.Width;
	}

	return -1;
}

//ǂݍݍς݂indexԍ̃eNX`̍Ԃ@G[Ȃ-1
int DxDraw::GetTextureHeight( int index )
{
	int temp_size = static_cast<int>( textureVector.size() );

	if( temp_size > index && temp_size > 0 )
	{
		D3DSURFACE_DESC desc;
		textureVector[index]->GetLevelDesc( 0, &desc );//eNX`TCY̎擾
		return desc.Height;
	}

	return -1;
}

//`IBobNobt@XN[ɔf@G[Ȃ-1Ԃ
int DxDraw::ScreenUpdate()
{
	if( NULL == renderD3DDevice )
	{
		return -1;
	}

	//obt@Xbv
	renderD3DDevice->Present( NULL, NULL, NULL, NULL );
	
	return 0;
}