#include "Enemy.h"

//RXgN^@Gxmlt@CAG摜ꂼꏀ
Enemy::Enemy(void) : movePattern(),
	enemyShot(),
	enemyEffect()
{
	for( int i = 0; i < MAX_STAGE; i++ )
	{
		//sDB̎͂ȂH
		std::ostringstream enemy_img;
		std::ostringstream enemy_data_file;

		enemy_img <<  "./SettingFiles/EnemyImage/Enemy" << ( i + 1 ) << ".png";
		enemy_data_file << "./SettingFiles/Xml/EnemyData" << ( i + 1 ) << ".xml";

		enemyImage.push_back( DX::dxCentral.LoadTexture( enemy_img.str().c_str() ) );

		if( enemyImage[ i ] == -1 )
		{
			ErrorMsgBox( "GC[W̓ǂݍ݃G[B\nI܂B" );
			exit( -1 );
		}

		fileName.push_back( enemy_data_file.str() );
	}

	soundHandle.push_back( DX::dxCentral.LoadWaveSound( L"./SettingFiles/Sound/EnemyDeath.wav", false ) );
	soundHandle.push_back( DX::dxCentral.LoadWaveSound( L"./SettingFiles/Sound/ShotHit.wav", false ) );

	int sound_length = static_cast<int>( soundHandle.size() );

	for( int k = 0; k < sound_length; k++ )
	{
		if( soundHandle[ k ] == -1 )
		{
			ErrorMsgBox( "EnemyTEh̓ǂݍ݃G[B\nI܂B" );
			exit( -1 );
		}
	}
}

//fXgN^@ɏȂB
Enemy::~Enemy(void)
{
}

//
void Enemy::Initialize( int stage )
{
	enData.clear();
	enemyShot.Initialize();

	for( int i = 0; i < EN_SHOW_MAX; i++ )
	{
		enShowData[ i ].Initialize();
	}

	LoadEnemyFile( fileName[ stage ] );
}

//G̑S̊Ǘ
void Enemy::EnemyControl( int stage_count, const PlayerData* player )
{
	RegisterData( stage_count );

	for( int i = 0; i < EN_SHOW_MAX; i++ )
	{
		if( enShowData[ i ].flag == 1 )
		{
			movePattern.CalcPattern( enShowData[ i ] );

			enShowData[ i ].count++;

			/*----------`߂̏----------*/
			enShowData[ i ].image_rect.top = enShowData[ i ].direction * enShowData[ i ].image_size.height;
			enShowData[ i ].image_rect.bottom = enShowData[ i ].image_rect.top + enShowData[ i ].image_size.height;
			enShowData[ i ].image_rect.left = enShowData[ i ].image_size.width * (( enShowData[ i ].count % 18 ) / 6 );
			enShowData[ i ].image_rect.right = enShowData[ i ].image_rect.left + enShowData[ i ].image_size.width;
			enShowData[ i ].location.x += ( cos( enShowData[ i ].angle ) * enShowData[ i ].speed ) + enShowData[ i ].vec_speed.x;
			enShowData[ i ].location.y += ( sin( enShowData[ i ].angle ) * enShowData[ i ].speed ) + enShowData[ i ].vec_speed.y;

			//G͈͂̔
			if( enShowData[ i ].location.x < -50 ||
				enShowData[ i ].location.x > LIMIT_SCOPE_END_X + 50 ||
				enShowData[ i ].location.y < -50 ||
				enShowData[ i ].location.y > LIMIT_SCOPE_END_Y + 50 )
			{
				enShowData[ i ].flag = 0;
			}
			
			if( enShowData[ i ].count == enShowData[ i ].barrage_time )
			{
				//Vbgo^
				enemyShot.RegisterShot( i, enShowData[ i ].barrage_kind );
			}

			DrawEnemyImage( i );
		}
	}

	enemyShot.ShotControl( &enShowData[ 0 ], player );//Vbg̐
	enemyEffect.EffectControl();//GtFNg
}

//G_[W炤
int Enemy::EnemyDamage( int enemy_num, int damage )
{
	enShowData[ enemy_num ].hitpoint -= damage;
	DX::dxCentral.PlayWaveSound( soundHandle[ 1 ] );

	if( enShowData[ enemy_num ].hitpoint < 0 )
	{
		enShowData[ enemy_num ].flag = 0;
		enemyShot.ShotCancel( enemy_num );
		DX::dxCentral.PlayWaveSound( soundHandle[ 0 ] );
		enemyEffect.RegisterEffect( enShowData[ enemy_num ].location, enShowData[ enemy_num ].effect );
		return DEAD;
	}
	
	return EXIST;
}

//Gf[^ԂB(\̂̂̂݁j
const EnemyData* Enemy::GetEnemyData() const
{
	return &enShowData[0];
}

//GVbgf[^Ԃ
const EnemyShotData* Enemy::GetShotData() const
{
	return enemyShot.GetShotData();
}

//ȇ傫Ԃ
const vector<Size>* Enemy::GetBulletSize() const
{
	return enemyShot.GetBulletSize();
}

//G摜`
void Enemy::DrawEnemyImage( int enemy_num )
{
	if( enShowData[ enemy_num ].flag > 0 )
	{
		DX::dxCentral.DrawTexture(
			enemyImage[ enShowData[ enemy_num ].kind ],
			enShowData[ enemy_num ].image_rect.left,
			enShowData[ enemy_num ].image_rect.top,
			enShowData[ enemy_num ].image_rect.right,
			enShowData[ enemy_num ].image_rect.bottom,
			static_cast<int>( enShowData[ enemy_num ].location.x - ( enShowData[ enemy_num ].image_size.width / 2 ) ),
			static_cast<int>( enShowData[ enemy_num ].location.y - ( enShowData[ enemy_num ].image_size.height / 2 ) ),
			enShowData[ enemy_num ].image_size.width,
			enShowData[ enemy_num ].image_size.height );
	}
}

//Gf[^̓o^
void Enemy::RegisterData( int stage_count )
{
	if( enData.size() <= 0 )
	{
		assert( !"Gt@Cǂݍł܂B");
	}

	int empty_num;
	int size = enData.size();

	for( int i = 0; i < size; i++ )
	{
		if( enData[ i ].count == stage_count )
		{
			empty_num = EmptyEnemyNumber();

			if( empty_num != -1 )
			{
				enShowData[ empty_num ].flag = 1;
				enShowData[ empty_num ].count = 0;
				enShowData[ empty_num ].pattern = enData[ i ].pattern;
				enShowData[ empty_num ].direction = 1;
				enShowData[ empty_num ].kind = enData[ i ].kind;
				enShowData[ empty_num ].effect = enData[ i ].effect;
				enShowData[ empty_num ].location.Set( enData[ i ].location.x, enData[ i ].location.y );
				enShowData[ empty_num ].speed = enData[ i ].speed;
				enShowData[ empty_num ].barrage_time = enData[ i ].barrage_time;
				enShowData[ empty_num ].barrage_kind = enData[ i ].barrage_kind;
				enShowData[ empty_num ].bullet_kind = enData[ i ].bullet_kind;
				enShowData[ empty_num ].wait_time = enData[ i ].wait_time;
				enShowData[ empty_num ].hitpoint = enData[ i ].hitpoint;
				enShowData[ empty_num ].vec_speed.Set( 0.0, 0.0 );
				enShowData[ empty_num ].angle = 0.0;
				enShowData[ empty_num ].image_size.Set( enData[ i ].image_size.width, enData[ i ].image_size.height );
			}
		}
	}
}

//󂢂ĂGf[^̗vfԍԂ
int Enemy::EmptyEnemyNumber()
{
	for( int i = 0; i < EN_SHOW_MAX; i++ )
	{
		if( enShowData[ i ].flag == 0 )
		{
			return i;
		}
	}

	return -1;
}

//Gt@C̓ǂݍ
void Enemy::LoadEnemyFile( std::string filename )
{
	XmlReader xml_reader;

	try
	{
		xml_reader.SetParseFile( filename, "EnemyData" );
	}
	catch( std::string error )
	{
		ErrorMsgBox( error );
		exit( -1 );
	}
	
	int length = xml_reader.GetNodeLength();

	if( length == 0 )
	{
		ErrorMsgBox( "Gf[^܂B\nt@CĂ\܂B\nI܂B" );
		exit( -1 );
	}

	enData.resize( length );

	for( int i = 0; i < length; i++ )
	{
		try
		{
			enData[ i ].count = xml_reader.GetNodeIntValue( i, "count" );
			enData[ i ].pattern = xml_reader.GetNodeIntValue( i, "pattern" );
			enData[ i ].kind = xml_reader.GetNodeIntValue( i, "kind" );
			enData[ i ].effect = xml_reader.GetNodeIntValue( i, "effect" );
			enData[ i ].hitpoint = xml_reader.GetNodeIntValue( i, "hitpoint" );
			enData[ i ].barrage_time = xml_reader.GetNodeIntValue( i, "barrage_time" );
			enData[ i ].barrage_kind = xml_reader.GetNodeIntValue( i, "barrage_kind" );
			enData[ i ].bullet_kind = xml_reader.GetNodeIntValue( i, "bullet_kind" );
			enData[ i ].speed = xml_reader.GetNodeDoubleValue( i, "speed" );
			enData[ i ].wait_time = xml_reader.GetNodeIntValue( i, "wait_time" );
			enData[ i ].location.Set( xml_reader.GetNodeDoubleValue( i, "locX"), xml_reader.GetNodeDoubleValue( i, "locY" ) );
			enData[ i ].image_size.Set( xml_reader.GetNodeIntValue( i, "img_width"), xml_reader.GetNodeIntValue( i, "img_height" ) );
		}
		catch( std::string error )
		{
			ErrorMsgBox( error );
			exit( -1 );
		}
		catch( ... )
		{
			ErrorMsgBox( "Gt@CǍŗ\ʃG[B\nI܂B" );
			exit( -1 );
		}
	}
}