#include "EnemyShot.h"

//RXgN^
EnemyShot::EnemyShot(void)
{
	for(int i = 0; i < EN_SHOT_KIND_MAX; i++)
	{
		std::ostringstream bullet_image;

		bullet_image << "./SettingFiles/EnemyShotImage/Shot" << ( i + 1 ) << ".png";

		bulletImage.push_back( DX::dxCentral.LoadTexture( bullet_image.str().c_str() ) );

		if( bulletImage.back() == -1 )
		{
			ErrorMsgBox( "GVbgC[W̓ǂݍ݃G[B\nI܂B" );
			exit( -1 );
		}

		imageSize.push_back(
			Size( 
			DX::dxCentral.GetTextureWidth( bulletImage.back() ),
			DX::dxCentral.GetTextureHeight( bulletImage.back() )
			)
			);

		if( imageSize.back().width == -1 || imageSize.back().height == -1)
		{
			ErrorMsgBox( "GVbgC[WTCY̓ǂݍ݃G[B\nI܂B" );
			exit( -1 );
		}
	}
}

//fXgN^
EnemyShot::~EnemyShot(void)
{
}

//@Xe[WɌĂяoB
void EnemyShot::Initialize()
{
	for( int i = 0; i < EN_SHOT_SHOW_MAX; i++ )
	{
		shotData[ i ].Initialize();
	}
}

//VbgS̊Ǘ
void EnemyShot::ShotControl( const EnemyData* enemy_data, const PlayerData* player_data )
{
	for( int i = 0; i < EN_SHOT_SHOW_MAX; i++ )
	{
		if( shotData[ i ].flag != 0 )
		{
			shotPattern.ShotPattern( shotData[ i ], enemy_data[ shotData[ i ].enemy_num ], *player_data );
			ShotCalc( enemy_data, i );
			shotData[ i ].count++;
		}
	}

	DrawEnemyShot();
}

//Vbg̓o^ EnemyData.barrage_kindɂĂB
void EnemyShot::RegisterShot( int enemy_num, int barrage_kind )
{
	for( int i = 0; i < EN_SHOT_SHOW_MAX; i++ )
	{
		if( shotData[ i ].flag == 0 && enemy_num < EN_SHOW_MAX )
		{
			shotData[ i ].flag = 1;
			shotData[ i ].enemy_num = enemy_num;
			shotData[ i ].kind = barrage_kind;//ꂪp^[Ɏgp܂B
			shotData[ i ].count = 0;
			return;
		}
	}
}

//Vbg̃LZ
void EnemyShot::ShotCancel( int enemy_num )
{
	for( int i = 0; i < EN_SHOT_SHOW_MAX; i++ )
	{
		if( shotData[ i ].flag != 0 )
		{
			if( shotData[ i ].enemy_num == enemy_num )
			{
				shotData[ i ].flag = 2;//ef[^̓o^֎~
				break;
			}
		}
	}
}

//Vbg
void EnemyShot::ShotClear( int shot_num, int bullet_num )
{
	shotData[ shot_num ].bullet[ bullet_num ].flag = 0;
}

//Vbgf[^Ԃ
const EnemyShotData* EnemyShot::GetShotData() const
{
	return &shotData[0];
}

//ȇ傫Ԃ
const vector<Size>* EnemyShot::GetBulletSize() const
{
	return &imageSize;
}

//evZs܂B
void EnemyShot::ShotCalc( const EnemyData* enemy_data, int shot_num )
{
	if( enemy_data[ shotData[ shot_num ].enemy_num ].flag != 1 )
	{
		shotData[ shot_num ].flag = 2;//e̓o^sԂ
	}

	for( int i = 0; i < BULLET_DATA_MAX; i++ )
	{
		if( shotData[ shot_num ].bullet[ i ].flag > 0 )
		{
			shotData[ shot_num ].bullet[ i ].location.x +=
				cos( shotData[ shot_num ].bullet[ i ].angle ) * shotData[ shot_num ].bullet[ i ].speed;

			shotData[ shot_num ].bullet[ i ].location.y +=
				sin( shotData[ shot_num ].bullet[ i ].angle ) * shotData[ shot_num ].bullet[ i ].speed;

			shotData[ shot_num ].bullet[ i ].count++;

			if( shotData[ shot_num ].bullet[ i ].location.x < -50 ||
				shotData[ shot_num ].bullet[ i ].location.x > LIMIT_SCOPE_END_X + 50 ||
				shotData[ shot_num ].bullet[ i ].location.y < -50 ||
				shotData[ shot_num ].bullet[ i ].location.y > LIMIT_SCOPE_END_Y + 50 )
			{
				shotData[ shot_num ].bullet[ i ].flag = 0;//OBeB
			}
		}
	}

	for( int k = 0; k < BULLET_DATA_MAX; k++ )
	{
		if( shotData[ shot_num ].bullet[ k ].flag > 0 )
		{
			return;
		}
	}

	if( enemy_data[ shotData[ shot_num ].enemy_num ].flag == 0 )
	{
		shotData[ shot_num ].flag = 0;
	}
}

void EnemyShot::DrawEnemyShot()
{
	for( int i = 0; i < EN_SHOT_SHOW_MAX; i++ )
	{
		if( shotData[ i ].flag > 0 )
		{
			for( int k = 0; k < BULLET_DATA_MAX; k++ )
			{
				if( shotData[ i ].bullet[ k ].flag != 0 )
				{
					DX::dxCentral.DrawTexture(
						bulletImage[ shotData[ i ].bullet[ k ].kind ],
						0,
						0,
						0,
						0,
						static_cast<int>( shotData[ i ].bullet[ k ].location.x - ( imageSize[ shotData[ i ].bullet[ k ].kind ].width / 2 ) ),
						static_cast<int>( shotData[ i ].bullet[ k ].location.y - ( imageSize[ shotData[ i ].bullet[ k ].kind ].height / 2 ) ),
						static_cast<int>( imageSize[ shotData[ i ].bullet[ k ].kind ].width ),
						static_cast<int>( imageSize[ shotData[ i ].bullet[ k ].kind ].height ) );
				}
			}
		}
	}
}