#include "ExplosionEffect.h"

ExplosionEffect::ExplosionEffect(void) : effectData( EFFECT_DATA_MAX )
{
	imageData.push_back( ImageData( DX::dxCentral.LoadTexture( "./SettingFiles/ExplosionEffect/Explosion.png" ), Size( 512, 192 ), Size( 64 ) ) );

	int length = static_cast<int>( imageData.size() );

	for( int i = 0; i < length; i++ )
	{
		if( imageData[ i ].image == -1 )
		{
			ErrorMsgBox( "GtFNg֘Af[^̓ǂݍ݃G[\nI܂B" );
			exit( -1 );
		}
	}
}

ExplosionEffect::~ExplosionEffect(void)
{
}

//GtFNg̒
void ExplosionEffect::EffectControl()
{
	CalcEffect();
	DrawEffect();
}

//GtFNg̓o^@͕\ʒu,GtFNg
void ExplosionEffect::RegisterEffect( Point& location, int effect_kind )
{
	if( effect_kind < 0 && effect_kind >= static_cast<int>( imageData.size() ) )
	{
		ErrorMsgBox( "GtFNg̓o^ł̃G[\neffect_kind̒lsłB\nI܂B" );
		exit( -1 );
	}

	int empty_num = EmptyEffectNumber();

	if( empty_num != -1 )
	{
		effectData[ empty_num ].flag = 1;
		effectData[ empty_num ].count = 0;
		effectData[ empty_num ].location.Set( location.x, location.y );
		effectData[ empty_num ].kind = effect_kind;
		effectData[ empty_num ].rect.Set( 0, 0, imageData[ effect_kind ].one_size.width, imageData[ effect_kind ].one_size.height );
	}
}

//󂢂ĂGtFNgzvfԍԂB-1ԂƎs
int ExplosionEffect::EmptyEffectNumber()
{
	for( int i = 0; i < EFFECT_DATA_MAX; i++ )
	{
		if( effectData[ i ].flag == 0 )
		{
			return i;
		}
	}

	return -1;
}

//GtFNǧvZ
void ExplosionEffect::CalcEffect()
{
	for( int i = 0; i < EFFECT_DATA_MAX; i++ )
	{
		if( effectData[ i ].flag > 0 )
		{
			switch( effectData[ i ].kind )
			{
			case 0://Ƃ肠1ނƂB
				if( effectData[ i ].count < 31 )
				{
					effectData[ i ].count++;
					effectData[ i ].rect.top = imageData[ effectData[ i ].kind ].one_size.height * ( ( effectData[ i ].count % 32 ) / 16 );//{͎Os...܂ڂȂɕςȂ̂2sB
					effectData[ i ].rect.bottom = effectData[ i ].rect.top + imageData[ effectData[ i ].kind ].one_size.height;
					effectData[ i ].rect.left = imageData[ effectData[ i ].kind ].one_size.width * ( ( effectData[ i ].count % 32 ) / 4 );
					effectData[ i ].rect.right = effectData[ i ].rect.left + imageData[ effectData[ i ].kind ].one_size.width;
				}
				else
				{
					effectData[ i ].flag = 0;//\IB
				}

				break;
			}
		}
	}
}

//GtFNg̕`
void ExplosionEffect::DrawEffect()
{
	for( int i = 0; i < EFFECT_DATA_MAX; i++ )
	{
		if( effectData[ i ].flag > 0 )
		{
			DX::dxCentral.DrawTexture( 
				imageData[ effectData[ i ].kind ].image,
				effectData[ i ].rect.left,
				effectData[ i ].rect.top,
				effectData[ i ].rect.right,
				effectData[ i ].rect.bottom,
				static_cast<int>( effectData[ i ].location.x - ( imageData[ effectData[ i ].kind ].one_size.width / 2 ) ),
				static_cast<int>( effectData[ i ].location.y - ( imageData[ effectData[ i ].kind ].one_size.height / 2 ) ),
				imageData[ effectData[ i ].kind ].one_size.width,
				imageData[ effectData[ i ].kind ].one_size.height );
		}
	}
}