#include "GameClear.h"

namespace Sequence
{
	namespace GameSequence
	{
		//RXgN^
		GameClear::GameClear( int stage_number ) : stageNumber( 0 ),
			clearImage( -1 ),
			imageShowCount( 0 )
		{
			stageNumber = stage_number;

			std::ostringstream clear_image;
			clear_image << "./SettingFiles/ClearImage/ClearImage" << ( stage_number + 1 ) << ".png";

			clearImage = DX::dxCentral.LoadTexture( clear_image.str().c_str() );
			clearSound = DX::dxCentral.LoadWaveSound( L"./SettingFiles/Sound/ClearSound.wav", false );

			if( clearImage == -1 )
			{
				ErrorMsgBox( "Clear摜̓ǂݍ݂Ɏs܂B\nI܂B" );
				exit( -1 );
			}
		}

		//fXgN^
		GameClear::~GameClear(void)
		{
			DX::dxCentral.DeleteAllTexture();
			DX::dxCentral.DeleteAllSound();
		}

		//ʂ̍XV
		void GameClear::Update( GameSequenceCentral* game_sequence_central )
		{
			if( imageShowCount == 0 )
			{
				DX::dxCentral.PlayWaveSound( clearSound );//NAĐ
			}

			if( imageShowCount == 250 )
			{
				if( stageNumber + 1 < MAX_STAGE )
				{
					game_sequence_central->MoveGameSequence( NEXT_GAME_STAGE_TITLE );
				}
				else
				{
					game_sequence_central->MoveSequence( NEXT_ENDING );
				}
			}

			DX::dxCentral.DrawTexture(
				clearImage,
				0,
				0,
				WINDOW_SIZE_X,
				WINDOW_SIZE_Y,
				0,
				0,
				WINDOW_SIZE_X,
				WINDOW_SIZE_Y );

			imageShowCount++;
		}
	}
}