#include "GamePlay.h"

namespace Sequence
{
	namespace GameSequence
	{
		//RXgN^
		GamePlay::GamePlay( int stage_number ) : bossFlag( false ),
			stageEndFlag( false ),
			stageEndCount( 0 ),
			stageNumber( stage_number ),
			stageCount( 0 ),
			enemyFightBGM( -1 ),
			bossFightBGM( -1 ),
			playerClass(),
			enemyClass(),
			bossClass(),
			hitJudgeClass(),
			keyData(),
			backGroundClass()
		{
			playerClass.Initialize( stage_number );
			enemyClass.Initialize( stageNumber );
			
			enemyFightBGM = DX::dxCentral.LoadWaveSound( L"./SettingFiles/BGM/Fight_BGM0.wav", true );
			bossFightBGM = DX::dxCentral.LoadWaveSound( L"./SettingFiles/BGM/Fight_BGM1.wav", true );

			if( enemyFightBGM == -1 || bossFightBGM == -1 )
			{
				ErrorMsgBox( "BGM̓ǂݍ݃G[B\nI܂B" );
				exit( -1 );
			}

			if( stage_number == 0)//ŏ̃Xe[WȂXRȀ
			{
				Score::NowScoreInitialize();
			}

			DX::dxCentral.PlayWaveSound( enemyFightBGM );
		}

		//fXgN^
		GamePlay::~GamePlay(void)
		{
			DX::dxCentral.DeleteAllTexture();
			DX::dxCentral.DeleteAllSound();
		}

		//ʂ̍XV
		void GamePlay::Update( GameSequenceCentral* game_sequence_central )
		{
			backGroundClass.Control( stageNumber );

			//{XoJEgɎ{X̏oB
			if( stageCount > BOSS_FIGHT_COUNT && bossFlag == false )
			{
				DX::dxCentral.DeleteSound( enemyFightBGM );
				DX::dxCentral.PlayWaveSound( bossFightBGM );
				bossClass.Initialize( stageNumber );
				bossFlag = true;
			}

			if( bossFlag == true )
			{
				//{X
				hitJudgeClass.HitJudgeCentral( bossClass, playerClass );
				bossClass.BossControl( playerClass.GetPlayerData() );
			}
			else
			{
				//GȈ
				hitJudgeClass.HitJudgeCentral( enemyClass, playerClass );
				enemyClass.EnemyControl( stageCount, ( playerClass.GetPlayerData() ) );
			}

			//L[͂̊Ď
			const char* keys = DX::dxCentral.GetKeyState();
			const int* key_count = DX::dxCentral.GetKeyCount();

			if( keys != NULL )
			{
				keyData.left = key_count[ DIK_LEFT ];
				keyData.right = key_count[ DIK_RIGHT ];
				keyData.down = key_count[ DIK_DOWN ];
				keyData.up = key_count[ DIK_UP ];
				keyData.shot = key_count[ DIK_Z ];
			}

			playerClass.PlayerControl( &keyData );//vC[
			stageCount++;

			if( key_count[ DIK_SPACE ] > 0 )//Xy[X|[Yʂ
			{
				game_sequence_central->MoveGameSequence( NEXT_GAME_PAUSE );
			}

			//{X|sȂ
			if( hitJudgeClass.BossDead() == true && stageEndFlag == false )
			{
				stageEndFlag = true;
				stageEndCount = stageCount + 300;
			}

			//{X|Xe[WIJEgtOݒ肳AJEgIJEgȏɂȂꍇANAʂ
			if( stageCount >= stageEndCount && stageEndFlag == true )
			{
				game_sequence_central->MoveGameSequence( NEXT_GAME_CLEAR_SHOW );
			}

			//vC[c@𒴂u]ꍇAQ[I[o[ʂ
			if( playerClass.CheckDeath() )
			{
				game_sequence_central->MoveSequence( NEXT_GAME_OVER );
			}
		}
	}
}