#include "GameSequenceCentral.h"

namespace Sequence
{
	namespace GameSequence
	{
		//RXgN^
		GameSequenceCentral::GameSequenceCentral( void ) : stageNumber( 0 ),
			nextSequence( NEXT_NONE ),
			gameNextSequence( NEXT_GAME_NONE ),
			gameBaseSequence( 0 ),
			bufferGameBaseSequence( 0 )
		{
			gameBaseSequence = new GameStageTitle( stageNumber );
		}

		//fXgN^
		GameSequenceCentral::~GameSequenceCentral( void )
		{
			SafeDelete( gameBaseSequence );
			SafeDelete( bufferGameBaseSequence );
		}

		//ʍXV
		void GameSequenceCentral::Update( SequenceCentral* sequence_central )
		{
			gameBaseSequence->Update( this );

			switch( gameNextSequence )
			{
			case NEXT_GAME_STAGE_TITLE:
				SafeDelete( gameBaseSequence );
				gameBaseSequence = new GameStageTitle( stageNumber );
				break;
			case NEXT_GAME_PLAY:
				SafeDelete( gameBaseSequence );
				gameBaseSequence = new GamePlay( stageNumber );
				break;
			case NEXT_GAME_PAUSE:
				bufferGameBaseSequence = gameBaseSequence;
				gameBaseSequence = new GamePause();
				break;
			case NEXT_GAME_PAUSE_CLEAR:
				SafeDelete( gameBaseSequence );
				gameBaseSequence = bufferGameBaseSequence;
				bufferGameBaseSequence = NULL;
				break;
			case NEXT_GAME_CLEAR_SHOW:
				SafeDelete( gameBaseSequence );
				gameBaseSequence = new GameClear( stageNumber );
				stageNumber++;
				break;
			}

			gameNextSequence = NEXT_GAME_NONE;

			if( nextSequence != NEXT_NONE )
			{
				sequence_central->MoveSequence( nextSequence );
				nextSequence = NEXT_NONE;
			}
		}

		//V[PXړ (Sequencepj
		void GameSequenceCentral::MoveSequence( NextSequence next_sequence )
		{
			if( nextSequence != NEXT_NONE )
			{
				ErrorMsgBox( "GameSequenceCentral MoveSequenceG[I sȏԂłB" );
				exit( -1 );
			}

			nextSequence = next_sequence;
		}

		//V[PXړ (GameSequencepj
		void GameSequenceCentral::MoveGameSequence( GameNextSequence game_next_sequence )
		{
			if( gameNextSequence != NEXT_GAME_NONE )
			{
				ErrorMsgBox( "GameSequenceCentral MoveGameSequenceG[I sȏԂłB" );
				exit( -1 );
			}

			gameNextSequence = game_next_sequence;
		}
	}
}