#include "GameStageTitle.h"

namespace Sequence
{
	namespace GameSequence
	{
		//RXgN^
		GameStageTitle::GameStageTitle( int stage_number ) : stageTitleImage( -1 ),
			imageShowCount( 0 ),
			titleSound( -1 )
		{
			std::ostringstream stage_title_image;
			stage_title_image << "./SettingFiles/StageTitleImage/StageTitle" << ( stage_number + 1 ) << ".png";

			stageTitleImage = DX::dxCentral.LoadTexture( stage_title_image.str().c_str() );
			titleSound = DX::dxCentral.LoadWaveSound( L"./SettingFiles/Sound/Enter.wav", false );

			if( stageTitleImage == -1 || titleSound == -1 )
			{
				ErrorMsgBox( "GameStageTitle摜or̓ǂݍ݂Ɏs܂B\nI܂B" );
				exit( -1 );
			}

			DX::dxCentral.PlayWaveSound( titleSound );
		}

		//fXgN^
		GameStageTitle::~GameStageTitle( void )
		{
			DX::dxCentral.DeleteAllTexture();
			DX::dxCentral.DeleteSound( titleSound );//DeleteAllSoundłʂɂ悢
		}

		//ʂ̍XV
		void GameStageTitle::Update( GameSequenceCentral* game_sequence_central )
		{
			if( imageShowCount == 150 )
			{
				game_sequence_central->MoveGameSequence( NEXT_GAME_PLAY );
			}

			DX::dxCentral.DrawTexture(
				stageTitleImage,
				0,
				0,
				WINDOW_SIZE_X,
				WINDOW_SIZE_Y,
				0,
				0,
				WINDOW_SIZE_X,
				WINDOW_SIZE_Y );

			imageShowCount++;
		}
	}
}