#include "HitJudge.h"

HitJudge::HitJudge(void) : gameScore(),
	bossDeadFlag( false )
{
}

HitJudge::~HitJudge(void)
{
}

//蔻蒆@GƎlNXn
void HitJudge::HitJudgeCentral( Enemy &enemy, Player &player )
{
	PlayerAndEnemyJudge( enemy, player );//l@ƓG@̏Փ˔
	PlayerShotAndEnemyJudge( enemy, player );//lVbgƓG@̏Փ˔
	PlayerAndEnemyShotJudge( enemy, player );//l@ƓGVbg̏Փ˔
	gameScore.ScoreControl();//XRA
}

//蔻蒆@{XƎlNXn
void HitJudge::HitJudgeCentral( Boss &boss, Player &player )
{
	PlayerAndBossJudge( boss, player );//l@ƓG@̏Փ˔
	PlayerShotAndBossJudge( boss, player );//lVbgƓG@̏Փ˔
	PlayerAndBossShotJudge( boss, player );//l@ƓGVbg̏Փ˔
	gameScore.ScoreControl();//XRA
}

//{X񂾂ǂ̃tOԂ
const bool HitJudge::BossDead() const
{
	return bossDeadFlag;
}

//GƎl@̏Փ˔
void HitJudge::PlayerAndEnemyJudge( Enemy& enemy, Player& player )
{
	const EnemyData* en_data = enemy.GetEnemyData();
	const PlayerData* pl_data = player.GetPlayerData();

	for( int i = 0; i < EN_SHOW_MAX; i++ )
	{
		if( en_data[ i ].flag == 1 )
		{
			double x = en_data[ i ].location.x - pl_data->location.x;
			double y = en_data[ i ].location.y - pl_data->location.y;
			double r = static_cast<double>( en_data[ i ].image_size.width ) / 2.0;//VrAȂ2.5ŏZ;

			if( x * x + y * y < r * r)
			{
				if( pl_data->flag == 0 && pl_data->invincible_count == 0 )
				{
					player.PlayerDeath();//vC[掀łB
					return;
				}
			}
		}
	}
}

//lVbgƓG@̏Փ˔
void HitJudge::PlayerShotAndEnemyJudge( Enemy& enemy, Player& player )
{
	const EnemyData* en_data = enemy.GetEnemyData();
	const PlayerShotData* pl_shot = player.GetShotData();

	for( int p_num = 0; p_num < PLAYER_SHOT_MAX; p_num++ )
	{
		if( pl_shot[ p_num ].flag > 0 )
		{
			for( int e_num = 0; e_num < EN_SHOW_MAX; e_num++ )
			{
				if( en_data[ e_num ].flag > 0 )
				{
					//Փ˔
					if( pl_shot[ p_num ].count > 0 )
					{
						double x = pl_shot[ p_num ].location.x - en_data[ e_num ].location.x;
						double y = pl_shot[ p_num ].location.y - en_data[ e_num ].location.y;
						double r = static_cast<double>( ( pl_shot[ p_num ].size.width / 2 ) - en_data[ e_num ].image_size.width );//邢Ȃen_data[ e_num ].image_size.widthĒ
						
						if( x * x + y * y < r * r )//s^SX̒藝
						{
							int status = enemy.EnemyDamage( e_num, pl_shot[ p_num ].power );//GɃ_[W^B

							if( status == DEAD )
							{
								gameScore.AddScore( ENEMY_ADD_SCORE );//EȂ_Z
							}

							player.ShotCancel( p_num );//VbgB
						}
						else if( pl_shot[ p_num ].speed > r )//ԂvZKv
						{
							//1t[Oɂʒui[
							double previous_x = pl_shot[ p_num ].location.x + cos( pl_shot[ p_num ].angle + CIRCLE_RATIO ) * pl_shot[ p_num ].speed;
							double previous_y = pl_shot[ p_num ].location.y + sin( pl_shot[ p_num ].angle + CIRCLE_RATIO ) * pl_shot[ p_num ].speed;
							double temp_x;
							double temp_y;
							int temp_judge = static_cast<int>( pl_shot[ p_num ].speed / r );

							for( int m = 0; m < temp_judge; m++ )//m͎̂gpB
							{
								temp_x = previous_x - en_data[ e_num ].location.x;
								temp_y = previous_y - en_data[ e_num ].location.y;

								if( temp_x * temp_x + temp_y * temp_y < r * r )//s^SX̒藝
								{
									int status = enemy.EnemyDamage( e_num, pl_shot[ p_num ].power );//GɃ_[W^B

									if( status == DEAD )
									{
										gameScore.AddScore( ENEMY_ADD_SCORE );//EȂ_Z
									}

									player.ShotCancel( p_num );//VbgB
								}

								previous_x += cos( pl_shot[ p_num ].angle ) * r;
								previous_y += sin( pl_shot[ p_num ].angle ) * r;
							}
						}
					}
				}
			}
		}
	}
}

//l@ƓGVbg̏Փ˔
void HitJudge::PlayerAndEnemyShotJudge( Enemy& enemy, Player& player )
{
	const EnemyShotData* en_shot = enemy.GetShotData();
	const PlayerData* pl_data = player.GetPlayerData();
	const std::vector<Size>* en_bullet_size = enemy.GetBulletSize();

	for( int i = 0; i < EN_SHOT_SHOW_MAX; i++ )
	{
		if( en_shot[ i ].flag > 0 )
		{
			for( int k = 0; k < BULLET_DATA_MAX; k++ )
			{
				if( en_shot[ i ].bullet[ k ].flag == 1 )
				{
					if( en_shot[ i ].bullet[ k ].count > 0 )
					{
						double x = en_shot[ i ].bullet[ k ].location.x - pl_data->location.x;
						double y = en_shot[ i ].bullet[ k ].location.y - pl_data->location.y;
						double r = static_cast<double>(
							( en_bullet_size->at( en_shot[ i ].bullet[ k ].kind ).width / 2 ) - ( pl_data->size.width / 2 ) );

						if( en_shot[ i ].bullet[ k ].speed > r )
						{
							double previous_x = 
								en_shot[ i ].bullet[ k ].location.x +
								cos( en_shot[ i ].bullet[ k ].angle + CIRCLE_RATIO ) * en_shot[ i ].bullet[ k ].speed;

							double previous_y = 
								en_shot[ i ].bullet[ k ].location.y +
								sin( en_shot[ i ].bullet[ k ].angle + CIRCLE_RATIO ) * en_shot[ i ].bullet[ k ].speed;

							double temp_x;
							double temp_y;
							int temp_judge = static_cast<int>( en_shot[ i ].bullet[ k ].speed / r );

							for( int m = 0; m < temp_judge; m++ )//m͎̂gpB
							{
								temp_x = previous_x - pl_data->location.x;
								temp_y = previous_y - pl_data->location.y;

								if( temp_x * temp_x + temp_y * temp_y < r * r )//s^SX̒藝
								{
									player.PlayerDeath();//vC[掀łB
								}

								previous_x += cos( en_shot[ i ].bullet[ k ].angle ) * r;
								previous_y += sin( en_shot[ i ].bullet[ k ].angle ) * r;
							}
						}

						if( x * x + y * y < r * r)//s^SX̒藝
						{
							player.PlayerDeath();//vC[悳悤Ȃ
						}
					}
				}
			}
		}
	}
}

//{XƎl@̏Փ˔
void HitJudge::PlayerAndBossJudge( Boss& boss, Player& player )
{
	const BossData* boss_data = boss.GetBossData();
	const PlayerData* pl_data = player.GetPlayerData();
	
	if( boss_data->flag == 1 )
	{
		double x = boss_data->location.x - pl_data->location.x;
		double y = boss_data->location.y - pl_data->location.y;
		double r = static_cast<double>( boss_data->image_size.width ) / 2.0;

		if( x * x + y * y < r * r )
		{
			if( pl_data->flag == 0 && pl_data->invincible_count == 0 )
			{
				player.PlayerDeath();//vC[掀łB
				return;
			}
		}
	}
}

//lVbgƃ{X̏Փ˔
void HitJudge::PlayerShotAndBossJudge( Boss& boss, Player& player )
{
	const BossData* boss_data = boss.GetBossData();
	const PlayerShotData* pl_shot = player.GetShotData();

	for( int p_num = 0; p_num < PLAYER_SHOT_MAX; p_num++ )
	{
		if( pl_shot[ p_num ].flag > 0 )
		{
			if( boss_data->flag > 0 )
			{
				if( pl_shot[ p_num ].count > 0 )
				{
					double x = pl_shot[ p_num ].location.x - boss_data->location.x;
					double y = pl_shot[ p_num ].location.y - boss_data->location.y;
					double r = static_cast<double>( ( pl_shot[ p_num ].size.width / 2 ) - boss_data->image_size.width / 3 );

					if( x * x + y * y < r * r )//s^SX̒藝
					{
						int status = boss.BossDamage( pl_shot[ p_num ].power );//GɃ_[W^B

						if( status == DEAD )
						{
							gameScore.AddScore( BOSS_ADD_SCORE );//EȂ_Z
							bossDeadFlag = true;
						}

						player.ShotCancel( p_num );//VbgB
					}
					else if( pl_shot[ p_num ].speed > r )//ԂvZKv
					{
						//1t[Oɂʒui[
						double previous_x = pl_shot[ p_num ].location.x + cos( pl_shot[ p_num ].angle + CIRCLE_RATIO ) * pl_shot[ p_num ].speed;
						double previous_y = pl_shot[ p_num ].location.y + sin( pl_shot[ p_num ].angle + CIRCLE_RATIO ) * pl_shot[ p_num ].speed;
						double temp_x;
						double temp_y;
						int temp_judge = static_cast<int>( pl_shot[ p_num ].speed / r );

						for( int m = 0; m < temp_judge; m++ )//m͎̂gpB
						{
							temp_x = previous_x - boss_data->location.x;
							temp_y = previous_y - boss_data->location.y;

							if( temp_x * temp_x + temp_y * temp_y < r * r )//s^SX̒藝
							{
								int status = boss.BossDamage( pl_shot[ p_num ].power );//GɃ_[W^B

								if( status == DEAD )
								{
									gameScore.AddScore( BOSS_ADD_SCORE );//EȂ_Z
								}

								player.ShotCancel( p_num );//VbgB
							}

							previous_x += cos( pl_shot[ p_num ].angle ) * r;
							previous_y += sin( pl_shot[ p_num ].angle ) * r;
						}
					}
				}
			}
		}
	}
}

//l@ƃ{XVbg̏Փ˔
void HitJudge::PlayerAndBossShotJudge( Boss& boss, Player& player )
{
	const BossShotData* boss_shot = boss.GetShotData();
	const PlayerData* pl_data = player.GetPlayerData();
	const std::vector<Size>* boss_bullet_size = boss.GetBulletSize();

	for( int i = 0; i < BOSS_SHOT_SHOW_MAX; i++ )
	{
		if( boss_shot[ i ].flag > 0 )
		{
			for( int k = 0; k < BULLET_DATA_MAX; k++ )
			{
				if( boss_shot[ i ].bullet[ k ].flag == 1 )
				{
					if( boss_shot[ i ].bullet[ k ].count > 0 )
					{
						double x = boss_shot[ i ].bullet[ k ].location.x - pl_data->location.x;
						double y = boss_shot[ i ].bullet[ k ].location.y - pl_data->location.y;
						double r = static_cast<double>(
							( boss_bullet_size->at( boss_shot[ i ].bullet[ k ].kind ).width / 2 ) - ( pl_data->size.width / 2 ) );

						if( x * x + y * y < r * r)//s^SX̒藝
						{
							player.PlayerDeath();//vC[悳悤Ȃ
						}
						else if( boss_shot[ i ].bullet[ k ].speed > r )
						{
							double previous_x = 
								boss_shot[ i ].bullet[ k ].location.x +
								cos( boss_shot[ i ].bullet[ k ].angle + CIRCLE_RATIO ) * boss_shot[ i ].bullet[ k ].speed;

							double previous_y = 
								boss_shot[ i ].bullet[ k ].location.y +
								sin( boss_shot[ i ].bullet[ k ].angle + CIRCLE_RATIO ) * boss_shot[ i ].bullet[ k ].speed;

							double temp_x;
							double temp_y;
							int temp_judge = static_cast<int>( boss_shot[ i ].bullet[ k ].speed / r );

							for( int m = 0; m < temp_judge; m++ )//m͎̂gpB
							{
								temp_x = previous_x - pl_data->location.x;
								temp_y = previous_y - pl_data->location.y;

								if( temp_x * temp_x + temp_y * temp_y < r * r )//s^SX̒藝
								{
									player.PlayerDeath();//vC[掀łB
								}

								previous_x += cos( boss_shot[ i ].bullet[ k ].angle ) * r;
								previous_y += sin( boss_shot[ i ].bullet[ k ].angle ) * r;
							}
						}
					}
				}
			}
		}
	}
}