#include "Player.h"

int Player::lifeCount = 5;//Ct

//RXgN^
Player::Player(void) : playerImage( 0 ),
	imageRect(),
	lifeImage( 0 ),
	deathSound( 0 ),
	fireTime( 5 ),
	playerData(),
	playerShot()
{
	playerImage = DX::dxCentral.LoadTexture( "./SettingFiles/CharacterImage/Character.png" );
	lifeImage = DX::dxCentral.LoadTexture( "./SettingFiles/CharacterImage/life.png" );
	deathSound = DX::dxCentral.LoadWaveSound( L"./SettingFiles/Sound/CharcterDeath.wav", false );

	if( playerImage == -1 || lifeImage == -1 )
	{
		ErrorMsgBox( "vC[֘A摜̓ǂݍ݃G[B\nI܂B" );
		exit( -1 );
	}
}

//fXgN^
Player::~Player(void)
{
	lifeCount = playerData.life;
}

//
void Player::Initialize( int stage_number )
{
	if( stage_number == 0 )
	{
		lifeCount = 5;
	}

	playerData.flag = 0;
	playerData.life = lifeCount;
	playerData.location.x = INITIAL_POSITION_X;
	playerData.location.y = INITIAL_POSITION_Y;
}

//SmF trueȂcO
bool Player::CheckDeath() const
{
	return ( playerData.life ? false : true );
}

//vC[SB(classfXgNgƂƂł͂ȂBj
void Player::PlayerDeath()
{
	if( playerData.flag == 0 && playerData.invincible_count == 0 )
	{
		playerData.flag = 2;//GԂ
		playerData.count = 0;
		DX::dxCentral.PlayWaveSound( deathSound );

		#ifndef _DEBUG
		if( playerData.life > 0 )
		{
			playerData.life--;
		}
		#endif
	}
}

//vC[VbgLZ
void Player::ShotCancel( int shot_num )
{
	playerShot.ShotCancel( shot_num );
}

//vC[̑S̊Ǘ
void Player::PlayerControl( const KeyData* key_data )
{
	bool right_and_left = false;//Eړ͂true
	bool up_and_down = false;//㉺ړ͂true
	double slant = 1.0;//΂߈ړ̍ۂɊli[iΐړ̍ۂ͂P/[gQɂȂƐړXs[hȂĂ܂߁j
	Point moved;//ړx,yl
	Vector2D speed( 4.0 );//ړx X(-AÉ{)AY(Ȃ-AȂ{)

	ChangePlayerImage();

	if( key_data->left > 0 )
	{
		imageRect.top = 140;
		imageRect.bottom = 210;

		right_and_left = true;
		moved.x = -speed.x;
	}
	else if ( key_data->right > 0 )
	{
		imageRect.top = 70;
		imageRect.bottom = 140;

		right_and_left = true;
		moved.x = speed.x;
	}
	else
	{
		imageRect.top = 0;
		imageRect.bottom = 70;
	}
	
	if( key_data->down > 0 )
	{
		up_and_down = true;
		moved.y = speed.y;
	}
	else if( key_data->up > 0 )
	{
		up_and_down = true;
		moved.y = -speed.y;
	}

	if( right_and_left == true || up_and_down == true )
	{
		if( right_and_left == true && up_and_down == true )
		{
			slant = sqrt( 2.0 );
		}

		moved.x /= slant;
		moved.y /= slant;
		moved.x += playerData.location.x;
		moved.y += playerData.location.y;

		if( !( moved.x < LIMIT_SCOPE_START_X + 5 || moved.x > LIMIT_SCOPE_END_X || 
			moved.y < LIMIT_SCOPE_START_Y + 30 || moved.y > LIMIT_SCOPE_END_Y - 30 ) )
		{
			playerData.location.x = moved.x;
			playerData.location.y = moved.y;
		}
	}

	if( key_data->shot > 0 )
	{
		playerData.shot_count++;
		
		if( playerData.shot_count % fireTime == 0 )
		{
			playerShot.RegisterShot( &playerData.location );
		}
	}
	else
	{
		playerData.shot_count = 0;
	}

	DrawPlayerImage();
	playerShot.ShotControl();
}

//vC[̈ʒuԂB
const PlayerData* Player::GetPlayerData() const
{
	return &playerData;
}

//Vbg̈ʒuԂB
const PlayerShotData* Player::GetShotData() const
{
	return playerShot.GetShotData();
}

//vC[C[W̕`
void Player::DrawPlayerImage()
{
	if( playerData.invincible_count % 2 == 0 )
	{
		DX::dxCentral.DrawTexture( 
			playerImage,
			imageRect.left,
			imageRect.top,
			imageRect.right,
			imageRect.bottom,
			static_cast<int>( playerData.location.x - ( playerData.size.width / 2 ) ),//^񒆂ɕ`߉摜̔̑傫}CiX
			static_cast<int>( playerData.location.y - ( playerData.size.height / 2 ) ),
			playerData.size.width,
			playerData.size.height );//v70*70̉摜ł

		for( int i = 0; i < playerData.life; i++ )
		{
			//}WbNio[͌ɍ\̎gpɐ؂ւ
			DX::dxCentral.DrawTexture(
				lifeImage,
				0,
				0,
				20,//CtC[W20̑傫B
				20,//CtC[W20̑傫B
				( 460 + ( 20 * i ) ),//`ʒuXlAiscorëʒuɕ`j
				115,//`ʒuYlAiscorëʒuɕ`j
				20,//CtC[W̑傫 20 * 20̑傫B
				20 );//CtC[W̑傫 20 * 20̑傫
		}
	}
}

//vC[C[W̕ύX
void Player::ChangePlayerImage()
{
	if( playerData.count == 0 && playerData.flag == 2 )
	{
		playerData.location.x = LIMIT_SCOPE_END_X / 2;
		playerData.location.y = LIMIT_SCOPE_END_Y + 30;
		playerData.invincible_count++;//GԂ
	}

	if( playerData.flag == 2 )//GԂȂ
	{
		playerData.location.y -= 1.5;

		if( playerData.count > 60 )
		{
			playerData.count = 0;
			playerData.flag = 0;
		}
	}

	if( playerData.invincible_count > 0 )
	{
		playerData.invincible_count++;

		if( playerData.invincible_count > 120 )
		{
			playerData.invincible_count = 0;
		}
	}

	playerData.count++;
	imageRect.left =  70 * ( ( playerData.count % 24 ) / 6 );//摜̐؂ւ
	imageRect.right = imageRect.left + 70;
}

