#include "PlayerShot.h"

//RXgN^
PlayerShot::PlayerShot(void) : shotImage( 0 ),
	shotSound( 0 ),
	rapidFire( 2 )
{
	drawLocation[0].x = -10;//ȉAVbg̕`ʒul
	drawLocation[0].y = -30;
	drawLocation[1].x = 10;
	drawLocation[1].y = -30;

	shotImage = DX::dxCentral.LoadTexture( "./SettingFiles/CharacterShotImage/Shot.png" );
	shotSound = DX::dxCentral.LoadWaveSound( L"./SettingFiles/Sound/CharacterShot.wav", false );

	if( shotImage == -1 || shotSound == -1 )
	{
		ErrorMsgBox( "vC[Vbg֘A摜܂͉f[^̓ǂݍ݃G[B\nI܂B" );
		exit( -1 );
	}
}

//fXgN^
PlayerShot::~PlayerShot(void)
{
}

//VbgS̊Ǘ
void PlayerShot::ShotControl()
{
	CalcShot();
	DrawShot();
}

//Vbg̓o^ G[Ȃ-1Ԃ@0 
void PlayerShot::RegisterShot( const Point* location )
{
	PrepareShot( location );//Vbg̏
}

//Vbg̃LZij
void PlayerShot::ShotCancel( int shot_num )
{
	shotData[ shot_num ].flag = 0;
}

//Vbgf[^ԂB
const PlayerShotData* PlayerShot::GetShotData() const
{
	return &shotData[0];
}

//Vbg̕`
void PlayerShot::DrawShot() const
{
	for( int i = 0; i < PLAYER_SHOT_MAX; i++ )
	{
		if( shotData[ i ].flag > 0 )
		{
			DX::dxCentral.DrawTexture(
				shotImage,
				0,
				0,
				0,
				0,
				static_cast<int>( shotData[ i ].location.x - ( shotData[ i ].size.width / 2 ) ),//^񒆂ɕ`߉摜̔̑傫}CiX
				static_cast<int>( shotData[ i ].location.y - ( shotData[ i ].size.height / 2 ) ),
				shotData[ i ].size.width,
				shotData[ i ].size.height );
		}
	}
}

//󂢂Ăeۂ̌@G[Ȃ-1ԂBȊOȂ󂫗vfԍԂ
int PlayerShot::SearchEmptyShot() const
{
	for( int i = 0; i < PLAYER_SHOT_MAX; i++ )
	{
		if( shotData[ i ].flag == 0 )
		{
			return i;
		}
	}

	return -1;
}

//Vbg̏
void PlayerShot::PrepareShot( const Point* location )
{
	int empty_num;

	for( int i = 0; i < rapidFire; i++ )
	{
		empty_num = SearchEmptyShot();

		if( empty_num != -1 )
		{
			shotData[ empty_num ].flag = 1;
			shotData[ empty_num ].count = 0;
			shotData[ empty_num ].angle = -CIRCLE_RATIO / 2;
			shotData[ empty_num ].speed = 20;
			shotData[ empty_num ].location.x = location->x + drawLocation[ i ].x;
			shotData[ empty_num ].location.y = location->y + drawLocation[ i ].y;
			shotData[ empty_num ].power = 50;
			shotData[ empty_num ].kind = 0;//gp

			DX::dxCentral.PlayWaveSound( shotSound );//ŔˉĐ
		}
	}
}

//Vbg̈ʒuvZ
void PlayerShot::CalcShot()
{
	for( int i = 0; i < PLAYER_SHOT_MAX; i++ )
	{
		if( shotData[ i ].flag == 1 )
		{
			int dran_x = static_cast<int>( shotData[ i ].speed + 11 / 2 );
			int dran_y = static_cast<int>( shotData[ i ].speed + 55 / 2 );

			shotData[ i ].location.x += cos( shotData[ i ].angle ) * shotData[ i ].speed;
			shotData[ i ].location.y += sin( shotData[ i ].angle ) * shotData[ i ].speed;
			shotData[ i ].count++;

			//ʊŐKl𒴂ĂVbgB
			if( shotData[ i ].location.x < -dran_x || 
				shotData[ i ].location.x > LIMIT_SCOPE_END_X + dran_x ||
				shotData[ i ].location.y < -dran_y ||
				shotData[ i ].location.y > LIMIT_SCOPE_END_Y + dran_y )
			{
				shotData[ i ].flag = 0;
			}
		}
	}
}