#include "SDKwavefile.h"

//RXgN^
CWaveFile::CWaveFile()
{
	m_pwfx = NULL;
	m_hmmio = NULL;
	m_pResourceBuffer = NULL;
	m_dwSize = 0;
	m_bIsReadingFromMemory = FALSE;
}

//fXgN^
CWaveFile::~CWaveFile()
{
	Close();

	if( !m_bIsReadingFromMemory )
		SAFE_DELETE_ARRAY( m_pwfx );
}


//WaveFileI[v@pwfx͓ǎ̏ꍇNULLł悢
HRESULT CWaveFile::Open( LPWSTR strFileName, WAVEFORMATEX* pwfx, DWORD dwFlags )
{
	HRESULT hr;
	m_dwFlags = dwFlags;
	m_bIsReadingFromMemory = FALSE;

	if( m_dwFlags == WAVEFILE_READ )//ǎŃI[v̏ꍇ
	{
		if( strFileName == NULL )
		{
			return E_INVALIDARG;
		}

		SAFE_DELETE_ARRAY( m_pwfx );

		m_hmmio = mmioOpen( strFileName, NULL, MMIO_ALLOCBUF | MMIO_READ );

		if( NULL == m_hmmio )
		{
			HRSRC hResInfo;
			HGLOBAL hResData;
			DWORD dwSize;
			VOID* pvRes;

			//̃W[ɂāÃ^CvƖO\[X̏ꏊ𒲂ׂ܂
			//ƁAw肵\[X̏ubÑnhԂ܂B@WAVE
			if( NULL == ( hResInfo = FindResource( NULL, strFileName, L"WAVE" ) ) )
			{
				//Ȃꍇ WAVŒׂ@ȂȂ玸s
				if( NULL == ( hResInfo = FindResource( NULL, strFileName, L"WAV" ) ) )
				{
					return DXTRACE_ERR( L"FindResource", E_FAIL );
				}
			}

			//w肳ꂽ\[XO[oɃ[hB
			if( NULL == ( hResData = LoadResource( GetModuleHandle( NULL ), hResInfo ) ) )
			{
				return DXTRACE_ERR( L"LoadResource", E_FAIL );
			}

			//w肵\[X̃TCYi oCgjԂ܂B
			if( 0 == ( dwSize = SizeofResource( GetModuleHandle( NULL ), hResInfo ) ) )
			{
				return DXTRACE_ERR( L"SizeofResource", E_FAIL );
			}

			//̎w肳ꂽ\[XbN
			if( NULL == ( pvRes = LockResource( hResData ) ) )
			{
				return DXTRACE_ERR( L"LockResource", E_FAIL );
			}

			m_pResourceBuffer = new CHAR[ dwSize ];

			//m_pResourceBuffermێsȂ玸s
			if( m_pResourceBuffer == NULL )
			{
				return DXTRACE_ERR( L"new", E_OUTOFMEMORY );
			}

			memcpy( m_pResourceBuffer, pvRes, dwSize );

			MMIOINFO mmioInfo;
			ZeroMemory( &mmioInfo, sizeof( mmioInfo ) );

			mmioInfo.fccIOProc = FOURCC_MEM;
			mmioInfo.cchBuffer = dwSize;
			mmioInfo.pchBuffer = ( CHAR* )m_pResourceBuffer;

			m_hmmio = mmioOpen( NULL, &mmioInfo, MMIO_ALLOCBUF | MMIO_READ );
		}

		if( FAILED( hr = ReadMMIO() ) )
		{
			mmioClose( m_hmmio, 0 );
			return DXTRACE_ERR( L"ReadMMIO", hr );
		}

		if( FAILED( hr = ResetFile() ) )
		{
			return DXTRACE_ERR( L"ResetFile", hr );
		}

		// Zbg, WAVEt@C̃TCYm_ck.cksizeɂB
		m_dwSize = m_ck.cksize;
	}
	else//݂ŃI[v
	{
		m_hmmio = mmioOpen( strFileName, NULL, MMIO_ALLOCBUF |
							MMIO_READWRITE |
							MMIO_CREATE );

		if( NULL == m_hmmio )
		{
			return DXTRACE_ERR( L"mmioOpen", E_FAIL );
		}

		if( FAILED( hr = WriteMMIO( pwfx ) ) )
		{
			mmioClose( m_hmmio, 0 );
			return DXTRACE_ERR( L"WriteMMIO", hr );
		}

		if( FAILED( hr = ResetFile() ) )
			return DXTRACE_ERR( L"ResetFile", hr );
	}

	return hr;
}

//̃f[^J
HRESULT CWaveFile::OpenFromMemory( BYTE* pbData, ULONG ulDataSize, WAVEFORMATEX* pwfx, DWORD dwFlags )
{
	m_pwfx = pwfx;
	m_ulDataSize = ulDataSize;
	m_pbData = pbData;
	m_pbDataCur = m_pbData;
	m_bIsReadingFromMemory = TRUE;

	if( dwFlags != WAVEFILE_READ )
	{
		return E_NOTIMPL;
	}

	return S_OK;
}

//}`fBA(MM) I/O Xg[ǂݍ
//m_hmmioLɂȂĂĂяoƁBm_ckRiff, m_pwfxXV
HRESULT CWaveFile::ReadMMIO()
{
	MMCKINFO ckIn;// chunkSʂɎgp
	PCMWAVEFORMAT pcmWaveFormat;//PCM\̂ǂݍ񂾂̂ꎞIɓ
	m_pwfx = NULL;

	//mmioOpenŊJ RIFFt@C̃`Nɐi܂
	if( ( 0 != mmioDescend( m_hmmio, &m_ckRiff, NULL, 0 ) ) )
	{
		return DXTRACE_ERR( L"mmioDescend", E_FAIL );
	}

	// wavet@CƂĎgpł̂`FbN
	if( ( m_ckRiff.ckid != FOURCC_RIFF ) || ( m_ckRiff.fccType != mmioFOURCC( 'W', 'A', 'V', 'E' ) ) )
	{
		return DXTRACE_ERR( L"mmioFOURCC", E_FAIL );
	}

	//'fmt '`Nԋp@mmioFOURCC̓}N
	ckIn.ckid = mmioFOURCC( 'f', 'm', 't', ' ' );

	//mmioOpenŊJ RIFFt@C̃`NɐiB MMIO_FINDCHUNKŎw肳ꂽ`Nʎq̃`N
	if( 0 != mmioDescend( m_hmmio, &ckIn, &m_ckRiff, MMIO_FINDCHUNK ) )
	{
		return DXTRACE_ERR( L"mmioDescend", E_FAIL );
	}

	//ȂƂ<PCMWAVEFORMAT>Ɠ傫ȏłȂȂ玸sƂ
	// gꂽli邢͗]ȒljIɍĂ͖
	if( ckIn.cksize < ( LONG )sizeof( PCMWAVEFORMAT ) )
	{
		return DXTRACE_ERR( L"sizeof(PCMWAVEFORMAT)", E_FAIL );
	}

	//'fmt '`N<pcmWaveFormat>ǂ
	if( mmioRead( m_hmmio, ( HPSTR )&pcmWaveFormat, sizeof( pcmWaveFormat ) ) != sizeof( pcmWaveFormat ) )
	{
		return DXTRACE_ERR( L"mmioRead", E_FAIL );
	}

	// WAVEFORMATEX蓖ĂBPCM formatłȂȂ,wordǂށA
	// Ċ蓖Ă]ȃoCg邩ׂiijand thats how many extra bytes to allocate.)
	if( pcmWaveFormat.wf.wFormatTag == WAVE_FORMAT_PCM )
	{
		m_pwfx = ( WAVEFORMATEX* )new CHAR[ sizeof( WAVEFORMATEX ) ];

		if( NULL == m_pwfx )
		{
			return DXTRACE_ERR( L"m_pwfx", E_FAIL );
		}

		//PCM\̂WaveFormat\̂փoCgRs[
		memcpy( m_pwfx, &pcmWaveFormat, sizeof( pcmWaveFormat ) );
		m_pwfx->cbSize = 0;
	}
	else
	{
		//]ȃoCg̒ǂ
		WORD cbExtraBytes = 0L;
		if( mmioRead( m_hmmio, ( CHAR* )&cbExtraBytes, sizeof( WORD ) ) != sizeof( WORD ) )
		{
			return DXTRACE_ERR( L"mmioRead", E_FAIL );
		}

		m_pwfx = ( WAVEFORMATEX* )new CHAR[ sizeof( WAVEFORMATEX ) + cbExtraBytes ];

		if( NULL == m_pwfx )
		{
			return DXTRACE_ERR( L"new", E_FAIL );
		}

		//PCM\̂WaveFormat\̂փoCgRs[
		memcpy( m_pwfx, &pcmWaveFormat, sizeof( pcmWaveFormat ) );
		m_pwfx->cbSize = cbExtraBytes;

		// ǂ񂾍\̗̓]oCg0ȊOȂ (ijnow read those extra bytes into the structure, if cbExtraAlloc != 0.)
		if( mmioRead( m_hmmio, ( CHAR* )( ( ( BYTE* )&( m_pwfx->cbSize ) ) + sizeof( WORD ) ), cbExtraBytes ) != cbExtraBytes )
		{
			SAFE_DELETE( m_pwfx );
			return DXTRACE_ERR( L"mmioRead", E_FAIL );
		}
	}

	//mmioDescend ֐Ői,RIFF t@C̃`N('fmt ')ޏo܂B
	if( 0 != mmioAscend( m_hmmio, &ckIn, 0 ) )
	{
		SAFE_DELETE( m_pwfx );
		return DXTRACE_ERR( L"mmioAscend", E_FAIL );
	}

	return S_OK;
}

//ǂݍWAVEt@C̃TCY擾
DWORD CWaveFile::GetSize()
{
	return m_dwSize;
}

//RIFF`N|C^( m_ck )t@C̐擪ɖ߂
HRESULT CWaveFile::ResetFile()
{
	if( m_bIsReadingFromMemory )//WAVEǂ񂾂H
	{
		m_pbDataCur = m_pbData;
	}
	else
	{
		if( m_hmmio == NULL )
		{
			return CO_E_NOTINITIALIZED;
		}

		if( m_dwFlags == WAVEFILE_READ )//ǂݍ݃I[vȂ
		{
			//V[N
			if( -1 == mmioSeek( m_hmmio, m_ckRiff.dwDataOffset + sizeof( FOURCC ), SEEK_SET ) )
			{
				return DXTRACE_ERR( L"mmioSeek", E_FAIL );
			}

			//'data'`N
			m_ck.ckid = mmioFOURCC( 'd', 'a', 't', 'a' );

			//mmioOpenŊJ RIFFt@C̃`NɐiB MMIO_FINDCHUNKŎw肳ꂽ`Nʎq̃`N
			if( 0 != mmioDescend( m_hmmio, &m_ck, &m_ckRiff, MMIO_FINDCHUNK ) )
			{
				return DXTRACE_ERR( L"mmioDescend", E_FAIL );
			}
		}
		else//݃I[vȂ
		{
			//'data'`N쐬B('data '`Nԋp@mmioFOURCC̓}N)
			m_ck.ckid = mmioFOURCC( 'd', 'a', 't', 'a' );
			m_ck.cksize = 0;

			//mmioOpen ֐ŊJꂽ RIFF t@CɃ`N쐬
			if( 0 != mmioCreateChunk( m_hmmio, &m_ck, 0 ) )
			{
				return DXTRACE_ERR( L"mmioCreateChunk", E_FAIL );
			}

			//mmioOpen ֐ŊJt@CɊւ擾
			if( 0 != mmioGetInfo( m_hmmio, &m_mmioinfoOut, 0 ) )
			{
				return DXTRACE_ERR( L"mmioGetInfo", E_FAIL );
			}
		}
	}

	return S_OK;
}


//WAVEt@Cǂݍ
HRESULT CWaveFile::Read( BYTE* pBuffer, DWORD dwSizeToRead, DWORD* pdwSizeRead )
{
	if( m_bIsReadingFromMemory )//̓ǂݍ݂Ȃ
	{
		if( m_pbDataCur == NULL )//CoInitializeĂяoĂȂȂ
		{
			return CO_E_NOTINITIALIZED;
		}

		if( pdwSizeRead != NULL )
		{
			*pdwSizeRead = 0;
		}

		if( ( BYTE* )( m_pbDataCur + dwSizeToRead ) > ( BYTE* )( m_pbData + m_ulDataSize ) )
		{
			dwSizeToRead = m_ulDataSize - ( DWORD )( m_pbDataCur - m_pbData );
		}

#pragma warning( disable: 4616 )    // disable warning about warning number '22104' being out of range
#pragma warning( disable: 22104 )   // disable PREfast warning during static code analysis
		CopyMemory( pBuffer, m_pbDataCur, dwSizeToRead );
#pragma warning( default: 22104 )
#pragma warning( default: 4616 )

		if( pdwSizeRead != NULL )
			*pdwSizeRead = dwSizeToRead;

		return S_OK;
	}
	else//t@C̓ǂݍ݂Ȃ
	{
		MMIOINFO mmioinfoIn;//m_hmmiǒ݂̃Xe[^X

		if( m_hmmio == NULL )//CoInitializeĂяoĂȂȂ
		{
			return CO_E_NOTINITIALIZED;
		}

		if( pBuffer == NULL || pdwSizeRead == NULL )
		{
			return E_INVALIDARG;
		}

		*pdwSizeRead = 0;

		//mmioOpen ֐ŊJt@CɊւ擾
		if( 0 != mmioGetInfo( m_hmmio, &mmioinfoIn, 0 ) )
		{
			return DXTRACE_ERR( L"mmioGetInfo", E_FAIL );
		}

		UINT cbDataIn = dwSizeToRead;

		if( cbDataIn > m_ck.cksize )
		{
			cbDataIn = m_ck.cksize;
		}

		m_ck.cksize -= cbDataIn;

		for( DWORD cT = 0; cT < cbDataIn; cT++ )
		{
			//IOobt@oCgRs[
			if( mmioinfoIn.pchNext == mmioinfoIn.pchEndRead )
			{
				//mmioGetInfo ֐ł̒ړo̓obt@ANZXpɃZbgAbvꂽt@C̓o̓obt@i߂
				if( 0 != mmioAdvance( m_hmmio, &mmioinfoIn, MMIO_READ ) )
				{
					return DXTRACE_ERR( L"mmioAdvance", E_FAIL );
				}

				if( mmioinfoIn.pchNext == mmioinfoIn.pchEndRead )
				{
					return DXTRACE_ERR( L"mmioinfoIn.pchNext", E_FAIL );
				}
			}

			//ۂɃRs[@...̃|C^̎g͏XB]TȂ璼B
			*( ( BYTE* )pBuffer + cT ) = *( ( BYTE* )mmioinfoIn.pchNext );

			mmioinfoIn.pchNext++;
		}

		//mmioOpen ֐gĊJt@CɂāAmmioGetInfo ֐Ŏ擾XV܂B
		if( 0 != mmioSetInfo( m_hmmio, &mmioinfoIn, 0 ) )
		{
			return DXTRACE_ERR( L"mmioSetInfo", E_FAIL );
		}

		*pdwSizeRead = cbDataIn;

		return S_OK;
	}
}

//WAVEt@C
HRESULT CWaveFile::Close()
{
	if( m_dwFlags == WAVEFILE_READ )//ǂݍ݃I[vȂ
	{
		//mmioOpen ֐ŊJt@CB
		mmioClose( m_hmmio, 0 );

		m_hmmio = NULL;
		SAFE_DELETE_ARRAY( m_pResourceBuffer );
	}
	else//݃I[vȂ
	{
		m_mmioinfoOut.dwFlags |= MMIO_DIRTY;

		if( m_hmmio == NULL )
			return CO_E_NOTINITIALIZED;

		if( 0 != mmioSetInfo( m_hmmio, &m_mmioinfoOut, 0 ) )
			return DXTRACE_ERR( L"mmioSetInfo", E_FAIL );

		//mmioDescend ֐ŐiA܂ mmioCreateChunk ֐ō쐬 RIFF t@C̃`Nޏo
		if( 0 != mmioAscend( m_hmmio, &m_ck, 0 ) )
		{
			return DXTRACE_ERR( L"mmioAscend", E_FAIL );
		}

		if( 0 != mmioAscend( m_hmmio, &m_ckRiff, 0 ) )
			return DXTRACE_ERR( L"mmioAscend", E_FAIL );

		//V[N
		mmioSeek( m_hmmio, 0, SEEK_SET );

		//mmioOpen ֐ŊJ RIFF t@C̃`Nɐi
		if( 0 != ( INT )mmioDescend( m_hmmio, &m_ckRiff, NULL, 0 ) )
		{
			return DXTRACE_ERR( L"mmioDescend", E_FAIL );
		}

		m_ck.ckid = mmioFOURCC( 'f', 'a', 'c', 't' );

		//'fact'T
		if( 0 == mmioDescend( m_hmmio, &m_ck, &m_ckRiff, MMIO_FINDCHUNK ) )
		{
			DWORD dwSamples = 0;
			mmioWrite( m_hmmio, ( HPSTR )&dwSamples, sizeof( DWORD ) );
			mmioAscend( m_hmmio, &m_ck, 0 );
		}

		if( 0 != mmioAscend( m_hmmio, &m_ckRiff, 0 ) )
		{
			return DXTRACE_ERR( L"mmioAscend", E_FAIL );
		}

		mmioClose( m_hmmio, 0 );
		m_hmmio = NULL;
	}

	return S_OK;
}

//MMIO(ڍׂXAudio2̃TvQƂj
HRESULT CWaveFile::WriteMMIO( WAVEFORMATEX* pwfxDest )
{
	DWORD dwFactChunk;
	MMCKINFO ckOut1;

	dwFactChunk = ( DWORD )-1;

	m_ckRiff.fccType = mmioFOURCC( 'W', 'A', 'V', 'E' );
	m_ckRiff.cksize = 0;

	if( 0 != mmioCreateChunk( m_hmmio, &m_ckRiff, MMIO_CREATERIFF ) )
	{
		return DXTRACE_ERR( L"mmioCreateChunk", E_FAIL );
	}

	m_ck.ckid = mmioFOURCC( 'f', 'm', 't', ' ' );
	m_ck.cksize = sizeof( PCMWAVEFORMAT );

	if( 0 != mmioCreateChunk( m_hmmio, &m_ck, 0 ) )
	{
		return DXTRACE_ERR( L"mmioCreateChunk", E_FAIL );
	}

	if( pwfxDest->wFormatTag == WAVE_FORMAT_PCM )
	{
		if( mmioWrite( m_hmmio, ( HPSTR )pwfxDest, sizeof( PCMWAVEFORMAT ) ) != sizeof( PCMWAVEFORMAT ) )
		{
			return DXTRACE_ERR( L"mmioWrite", E_FAIL );
		}
	}
	else
	{
		if( ( UINT )mmioWrite( 
			m_hmmio, 
			( HPSTR )pwfxDest,
			sizeof( *pwfxDest ) + pwfxDest->cbSize ) != ( sizeof( *pwfxDest ) + pwfxDest->cbSize ) )
		{
			return DXTRACE_ERR( L"mmioWrite", E_FAIL );
		}
	}

	if( 0 != mmioAscend( m_hmmio, &m_ck, 0 ) )
	{
		return DXTRACE_ERR( L"mmioAscend", E_FAIL );
	}

	ckOut1.ckid = mmioFOURCC( 'f', 'a', 'c', 't' );
	ckOut1.cksize = 0;

	if( 0 != mmioCreateChunk( m_hmmio, &ckOut1, 0 ) )
	{
		return DXTRACE_ERR( L"mmioCreateChunk", E_FAIL );
	}

	if( mmioWrite( 
		m_hmmio,
		( HPSTR )&dwFactChunk,
		sizeof( dwFactChunk ) ) != sizeof( dwFactChunk ) )
	{
		return DXTRACE_ERR( L"mmioWrite", E_FAIL );
	}

	if( 0 != mmioAscend( m_hmmio, &ckOut1, 0 ) )
	{
		return DXTRACE_ERR( L"mmioAscend", E_FAIL );
	}

	return S_OK;
}

//WAVEt@Cւ̏
HRESULT CWaveFile::Write( UINT nSizeToWrite, BYTE* pbSrcData, UINT* pnSizeWrote )
{
	UINT cT;

	if( m_bIsReadingFromMemory )//̓ǂݍ݂Ȃ
	{
		return E_NOTIMPL;
	}

	if( m_hmmio == NULL )//CoInitializeĂяoĂȂȂ
	{
		return CO_E_NOTINITIALIZED;
	}
	
	if( pnSizeWrote == NULL || pbSrcData == NULL )
	{
		return E_INVALIDARG;
	}

	*pnSizeWrote = 0;

	for( cT = 0; cT < nSizeToWrite; cT++ )
	{
		if( m_mmioinfoOut.pchNext == m_mmioinfoOut.pchEndWrite )
		{
			m_mmioinfoOut.dwFlags |= MMIO_DIRTY;

			if( 0 != mmioAdvance( m_hmmio, &m_mmioinfoOut, MMIO_WRITE ) )
			{
				return DXTRACE_ERR( L"mmioAdvance", E_FAIL );
			}
		}

		*( ( BYTE* )m_mmioinfoOut.pchNext ) = *( ( BYTE* )pbSrcData + cT );
		( BYTE* )m_mmioinfoOut.pchNext++;
		( *pnSizeWrote )++;
	}

	return S_OK;
}

//ǂݍWAVEt@C̃TCY擾
WAVEFORMATEX* CWaveFile::GetFormat()
{
	return m_pwfx;
}