#include "SequenceCentral.h"

namespace Sequence
{
	SequenceCentral* SequenceCentral::centralInstance = 0;

	//ʍXV
	void SequenceCentral::Update()
	{
		baseSequence->Update( this );

		switch( nextSequence )
		{
		case NEXT_TITLE:
			SafeDelete( baseSequence );
			baseSequence = new Title();
			break;
		case NEXT_GAME:
			SafeDelete( baseSequence );
			baseSequence = new Game();
			break;
		case NEXT_GAME_OVER:
			SafeDelete( baseSequence );
			baseSequence = new GameOver();
			break;
		case NEXT_ENDING:
			SafeDelete( baseSequence );
			baseSequence = new Ending();
			break;
		}

		nextSequence = NEXT_NONE;
	}

	//V[PXړ
	void SequenceCentral::MoveSequence( NextSequence next_sequence )
	{
		if( nextSequence != NEXT_NONE )
		{
			ErrorMsgBox( "V[PXړ̃G[\nI܂B" );
			exit( -1 );
		}

		nextSequence = next_sequence;
	}

	//̍쐬
	void SequenceCentral::Create()
	{
		if( centralInstance != 0 )
		{
			ErrorMsgBox( "V[PX̂ɑ݂܂B\nvIG[̂ߏI܂B" );
			exit( -1 );
		}

		centralInstance = new SequenceCentral();
	}

	//̏
	void SequenceCentral::Destroy()
	{
		if( centralInstance != 0 )
		{
			delete( centralInstance );
			centralInstance = 0;
		}
	}

	//̎擾
	SequenceCentral* SequenceCentral::GetInstance()
	{
		return centralInstance;
	}

	//privateRXgN^
	SequenceCentral::SequenceCentral(void) : nextSequence( NEXT_NONE ),
		baseSequence( NULL )
	{
		baseSequence = new Title();//ŏ̓^Cg
	}

	//privatefXgN^
	SequenceCentral::~SequenceCentral(void)
	{
		SafeDelete( baseSequence );
	}
}