#include "XmlReader.h"

//RXgN^ Xerces̏ōsȂB
XmlReader::XmlReader(void) : nodeLength( 0 )
{
	domParser = NULL;
	domDocument = NULL;
	rootElement = NULL;
	nodeList = NULL;

	try
	{
		XMLPlatformUtils::Initialize();
	}
	catch( ... )//胍OƂȂconst XMLException& Lb`
	{
		ErrorMsgBox( "xmls" );
		exit( -1 );
	}
}

//fXgN^@o|C^̉AXerces̏IōsȂB
XmlReader::~XmlReader(void)
{
	SafeDelete( domParser );
	XMLPlatformUtils::Terminate();
}

//XMLt@C̓ǂݍ
void XmlReader::SetParseFile( std::string file_name, string tag_name )
{
	SafeDelete( domParser );

	domParser = new XercesDOMParser;
	domParser->parse( file_name.c_str() );

	domDocument = domParser->getDocument();

	if( domDocument == NULL )
	{
		std::ostringstream ex;
		ex << file_name << "͂ł܂B\ni getDocument̎s j";
		throw ex.str();
	}

	rootElement = domDocument->getDocumentElement();

	if( rootElement == NULL )
	{
		std::ostringstream ex;
		ex << file_name << "͂ł܂B\ni getDocumentElement̎s j";
		throw ex.str();
	}

	nodeList = GetElement( rootElement, tag_name );

	if( static_cast<int>( nodeList->getLength() ) == 0 )
	{
		std::ostringstream ex;
		ex << file_name << "͂ł܂B\ni GetElement̎s nodeListłBj";
		throw ex.str();
	}
		
	nodeLength = static_cast<int>( nodeList->getLength() );
}

//onodeLengthԂ
int XmlReader::GetNodeLength() const
{
	return nodeLength;
}

//w肵vfԍ̃m[h̒lintŕԂB
int XmlReader::GetNodeIntValue( int element_num, std::string tag_name )
{
	if( element_num < 0 || element_num > nodeLength )
	{
		throw std::string("Elementvfԍ̋EG[łBm[hl擾ł܂B");
	}

	DOMNodeList* temp_node = GetElement( dynamic_cast<DOMElement*>( nodeList->item( element_num ) ) , tag_name );

	if( static_cast<int>( temp_node->getLength() ) == 0 )
	{
		std::ostringstream ex;
		ex << element_num << " : " << tag_name << " : " << "m[hl擾ł܂B";
		throw ex.str();
	}

	DOMNode* dom_node = temp_node->item( 0 )->getFirstChild();
	const XMLCh* node_txt = dom_node->getNodeValue();
	char* temp_str = XMLString::transcode( node_txt );
	int result = atoi( temp_str );
	XMLString::release( &temp_str );

	return result;
}

//w肵vfԍ̃m[h̒ldoubleŕԂB
double XmlReader::GetNodeDoubleValue( int element_num, string tag_name )
{
	if( element_num < 0 || element_num > nodeLength )
	{
		throw std::string("Elementvfԍ̋EG[łBm[hl擾ł܂B");
	}

	DOMNodeList* temp_node = GetElement( dynamic_cast<DOMElement*>( nodeList->item( element_num ) ), tag_name );

	if( static_cast<int>( temp_node->getLength() ) == 0 )
	{
		std::ostringstream ex;
		ex << element_num << " : " << tag_name << " : " << "m[hl擾ł܂B";
		throw ex.str();
	}

	const XMLCh* node_txt = ( ( temp_node->item( 0 ) )->getFirstChild() )->getNodeValue();
	char* temp_str = XMLString::transcode( node_txt );
	double result = atof( temp_str );
	XMLString::release( &temp_str );

	return result;
}

//^Oqvf擾
DOMNodeList* XmlReader::GetElement( DOMElement* element, string tag_name )
{
	XMLCh* attributeName = XMLString::transcode( tag_name.c_str() );
	DOMNodeList* node_list = element->getElementsByTagName( attributeName );
	XMLString::release( &attributeName );

	return node_list;
}